#property indicator_buffers 2
#property indicator_chart_window
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_level1 0

#define sizeStep 1000
double SignalBuffer1[0];
double SignalBuffer2[0];

double lineBuffer1[];
double lineBuffer2[];

extern int period1 = 100;
extern int period2 = 15;
extern int maType = MODE_LWMA;

extern bool isMaOnArray = true;

int i;
int init(){
   SetIndexBuffer(0, lineBuffer1);
   SetIndexBuffer(1, lineBuffer2);
   IndicatorDigits(Digits + 1);
}
int sizeNow = 0;
int start(){
   if(sizeNow < Bars) {
      int step = sizeStep;
      if(Bars - sizeNow > step) {
         step = Bars - sizeNow + step;
      }
      sizeNow = sizeNow + step;
      utils.resizeArray(sizeNow, SignalBuffer1);
      utils.resizeArray(sizeNow, SignalBuffer2);
   }
   
   
   int counted_bars =  IndicatorCounted();
   if(counted_bars>0) {
      counted_bars--;
   }
   int limit = Bars - counted_bars - 1;
   for(i = limit; i >= 0; i--) {
       utils.setManualBuffer(SignalBuffer1, iMA(NULL, 0, period1, 0, maType, 0, i), i); 
       utils.setManualBuffer(SignalBuffer2, utils.iMAOnArray(SignalBuffer1, period2, i), i);       
   }

   for(i = limit; i >= 0; i--) {
       lineBuffer1[i]= utils.getManualBuffer(SignalBuffer1, i);
       lineBuffer2[i]= utils.getManualBuffer(SignalBuffer2, i);     
   }
}

double utils.iMAOnArray(double &buffer[], int period, int shift) {
   //if(shift > 200 ) {
   //   return(0);
   //}
   if(isMaOnArray){
      double value = iMAOnArray(buffer, 0, period, 0, maType, Bars - 1 - shift);
   } else {
      value = LWMA(buffer, period, Bars - 1-shift);
   }
   return(value);
}

double LWMA(double array[],int per,int bar){
   double Sum = 0;
   double Weight = 0;
   
   for(int i = 0;i < per;i++){ 
      Weight+= (per - i);
      Sum += array[bar-i]*(per - i);
   }
   if(Weight>0) {
      double lwma = Sum/Weight;
   } else {
      lwma = 0; 
   }
   return(lwma);
} 

void utils.resizeArray(int newSize, double &buffer[]) {
   if(ArrayGetAsSeries(buffer)) {
      ArraySetAsSeries(buffer, false);
   }
   ArrayResize(buffer, newSize);
   ArraySetAsSeries(buffer, true);  
}

bool utils.setManualBuffer(double &buffer[], double value, int shift) {
   buffer[Bars - 1 - shift] = value;
}

double utils.getManualBuffer(double &buffer[], int shift) {
   return(buffer[Bars - 1 - shift]);
}